<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>21.22. http.server — HTTP servers &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="21. Internet Protocols and Support" href="internet.html" />
    <link rel="next" title="21.23. http.cookies — HTTP state management" href="http.cookies.html" />
    <link rel="prev" title="21.21. socketserver — A framework for network servers" href="socketserver.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="http.cookies.html" title="21.23. http.cookies — HTTP state management"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="socketserver.html" title="21.21. socketserver — A framework for network servers"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="internet.html" accesskey="U">21. Internet Protocols and Support</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-http.server">
<span id="http-server-http-servers"></span><h1>21.22. <a class="reference internal" href="#module-http.server" title="http.server: HTTP server and request handlers."><code class="xref py py-mod docutils literal"><span class="pre">http.server</span></code></a> &#8212; HTTP servers<a class="headerlink" href="#module-http.server" title="Permalink to this headline">¶</a></h1>
<p id="index-0"><strong>Source code:</strong> <a class="reference external" href="https://hg.python.org/cpython/file/3.5/Lib/http/server.py">Lib/http/server.py</a></p>
<hr class="docutils" />
<p>This module defines classes for implementing HTTP servers (Web servers).</p>
<p>One class, <a class="reference internal" href="#http.server.HTTPServer" title="http.server.HTTPServer"><code class="xref py py-class docutils literal"><span class="pre">HTTPServer</span></code></a>, is a <code class="xref py py-class docutils literal"><span class="pre">socketserver.TCPServer</span></code> subclass.
It creates and listens at the HTTP socket, dispatching the requests to a
handler.  Code to create and run the server looks like this:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="n">server_class</span><span class="o">=</span><span class="n">HTTPServer</span><span class="p">,</span> <span class="n">handler_class</span><span class="o">=</span><span class="n">BaseHTTPRequestHandler</span><span class="p">):</span>
    <span class="n">server_address</span> <span class="o">=</span> <span class="p">(</span><span class="s">&#39;&#39;</span><span class="p">,</span> <span class="mi">8000</span><span class="p">)</span>
    <span class="n">httpd</span> <span class="o">=</span> <span class="n">server_class</span><span class="p">(</span><span class="n">server_address</span><span class="p">,</span> <span class="n">handler_class</span><span class="p">)</span>
    <span class="n">httpd</span><span class="o">.</span><span class="n">serve_forever</span><span class="p">()</span>
</pre></div>
</div>
<dl class="class">
<dt id="http.server.HTTPServer">
<em class="property">class </em><code class="descclassname">http.server.</code><code class="descname">HTTPServer</code><span class="sig-paren">(</span><em>server_address</em>, <em>RequestHandlerClass</em><span class="sig-paren">)</span><a class="headerlink" href="#http.server.HTTPServer" title="Permalink to this definition">¶</a></dt>
<dd><p>This class builds on the <code class="xref py py-class docutils literal"><span class="pre">TCPServer</span></code> class by storing
the server address as instance variables named <code class="xref py py-attr docutils literal"><span class="pre">server_name</span></code> and
<code class="xref py py-attr docutils literal"><span class="pre">server_port</span></code>. The server is accessible by the handler, typically
through the handler&#8217;s <code class="xref py py-attr docutils literal"><span class="pre">server</span></code> instance variable.</p>
</dd></dl>

<p>The <a class="reference internal" href="#http.server.HTTPServer" title="http.server.HTTPServer"><code class="xref py py-class docutils literal"><span class="pre">HTTPServer</span></code></a> must be given a <em>RequestHandlerClass</em> on instantiation,
of which this module provides three different variants:</p>
<dl class="class">
<dt id="http.server.BaseHTTPRequestHandler">
<em class="property">class </em><code class="descclassname">http.server.</code><code class="descname">BaseHTTPRequestHandler</code><span class="sig-paren">(</span><em>request</em>, <em>client_address</em>, <em>server</em><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler" title="Permalink to this definition">¶</a></dt>
<dd><p>This class is used to handle the HTTP requests that arrive at the server.  By
itself, it cannot respond to any actual HTTP requests; it must be subclassed
to handle each request method (e.g. GET or POST).
<a class="reference internal" href="#http.server.BaseHTTPRequestHandler" title="http.server.BaseHTTPRequestHandler"><code class="xref py py-class docutils literal"><span class="pre">BaseHTTPRequestHandler</span></code></a> provides a number of class and instance
variables, and methods for use by subclasses.</p>
<p>The handler will parse the request and the headers, then call a method
specific to the request type. The method name is constructed from the
request. For example, for the request method <code class="docutils literal"><span class="pre">SPAM</span></code>, the <code class="xref py py-meth docutils literal"><span class="pre">do_SPAM()</span></code>
method will be called with no arguments. All of the relevant information is
stored in instance variables of the handler.  Subclasses should not need to
override or extend the <a class="reference internal" href="../reference/datamodel.html#object.__init__" title="object.__init__"><code class="xref py py-meth docutils literal"><span class="pre">__init__()</span></code></a> method.</p>
<p><a class="reference internal" href="#http.server.BaseHTTPRequestHandler" title="http.server.BaseHTTPRequestHandler"><code class="xref py py-class docutils literal"><span class="pre">BaseHTTPRequestHandler</span></code></a> has the following instance variables:</p>
<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.client_address">
<code class="descname">client_address</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.client_address" title="Permalink to this definition">¶</a></dt>
<dd><p>Contains a tuple of the form <code class="docutils literal"><span class="pre">(host,</span> <span class="pre">port)</span></code> referring to the client&#8217;s
address.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.server">
<code class="descname">server</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.server" title="Permalink to this definition">¶</a></dt>
<dd><p>Contains the server instance.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.close_connection">
<code class="descname">close_connection</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.close_connection" title="Permalink to this definition">¶</a></dt>
<dd><p>Boolean that should be set before <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.handle_one_request" title="http.server.BaseHTTPRequestHandler.handle_one_request"><code class="xref py py-meth docutils literal"><span class="pre">handle_one_request()</span></code></a> returns,
indicating if another request may be expected, or if the connection should
be shut down.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.requestline">
<code class="descname">requestline</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.requestline" title="Permalink to this definition">¶</a></dt>
<dd><p>Contains the string representation of the HTTP request line. The
terminating CRLF is stripped. This attribute should be set by
<a class="reference internal" href="#http.server.BaseHTTPRequestHandler.handle_one_request" title="http.server.BaseHTTPRequestHandler.handle_one_request"><code class="xref py py-meth docutils literal"><span class="pre">handle_one_request()</span></code></a>. If no valid request line was processed, it
should be set to the empty string.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.command">
<code class="descname">command</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.command" title="Permalink to this definition">¶</a></dt>
<dd><p>Contains the command (request type). For example, <code class="docutils literal"><span class="pre">'GET'</span></code>.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.path">
<code class="descname">path</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.path" title="Permalink to this definition">¶</a></dt>
<dd><p>Contains the request path.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.request_version">
<code class="descname">request_version</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.request_version" title="Permalink to this definition">¶</a></dt>
<dd><p>Contains the version string from the request. For example, <code class="docutils literal"><span class="pre">'HTTP/1.0'</span></code>.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.headers">
<code class="descname">headers</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.headers" title="Permalink to this definition">¶</a></dt>
<dd><p>Holds an instance of the class specified by the <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.MessageClass" title="http.server.BaseHTTPRequestHandler.MessageClass"><code class="xref py py-attr docutils literal"><span class="pre">MessageClass</span></code></a> class
variable. This instance parses and manages the headers in the HTTP
request. The <code class="xref py py-func docutils literal"><span class="pre">parse_headers()</span></code> function from
<a class="reference internal" href="http.client.html#module-http.client" title="http.client: HTTP and HTTPS protocol client (requires sockets)."><code class="xref py py-mod docutils literal"><span class="pre">http.client</span></code></a> is used to parse the headers and it requires that the
HTTP request provide a valid <span class="target" id="index-1"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2822.html"><strong>RFC 2822</strong></a> style header.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.rfile">
<code class="descname">rfile</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.rfile" title="Permalink to this definition">¶</a></dt>
<dd><p>Contains an input stream, positioned at the start of the optional input
data.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.wfile">
<code class="descname">wfile</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.wfile" title="Permalink to this definition">¶</a></dt>
<dd><p>Contains the output stream for writing a response back to the
client. Proper adherence to the HTTP protocol must be used when writing to
this stream.</p>
</dd></dl>

<p><a class="reference internal" href="#http.server.BaseHTTPRequestHandler" title="http.server.BaseHTTPRequestHandler"><code class="xref py py-class docutils literal"><span class="pre">BaseHTTPRequestHandler</span></code></a> has the following class variables:</p>
<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.server_version">
<code class="descname">server_version</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.server_version" title="Permalink to this definition">¶</a></dt>
<dd><p>Specifies the server software version.  You may want to override this. The
format is multiple whitespace-separated strings, where each string is of
the form name[/version]. For example, <code class="docutils literal"><span class="pre">'BaseHTTP/0.2'</span></code>.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.sys_version">
<code class="descname">sys_version</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.sys_version" title="Permalink to this definition">¶</a></dt>
<dd><p>Contains the Python system version, in a form usable by the
<a class="reference internal" href="#http.server.BaseHTTPRequestHandler.version_string" title="http.server.BaseHTTPRequestHandler.version_string"><code class="xref py py-attr docutils literal"><span class="pre">version_string</span></code></a> method and the <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.server_version" title="http.server.BaseHTTPRequestHandler.server_version"><code class="xref py py-attr docutils literal"><span class="pre">server_version</span></code></a> class
variable. For example, <code class="docutils literal"><span class="pre">'Python/1.4'</span></code>.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.error_message_format">
<code class="descname">error_message_format</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.error_message_format" title="Permalink to this definition">¶</a></dt>
<dd><p>Specifies a format string for building an error response to the client. It
uses parenthesized, keyed format specifiers, so the format operand must be
a dictionary. The <em>code</em> key should be an integer, specifying the numeric
HTTP error code value. <em>message</em> should be a string containing a
(detailed) error message of what occurred, and <em>explain</em> should be an
explanation of the error code number. Default <em>message</em> and <em>explain</em>
values can found in the <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.responses" title="http.server.BaseHTTPRequestHandler.responses"><code class="xref py py-attr docutils literal"><span class="pre">responses</span></code></a> class variable.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.error_content_type">
<code class="descname">error_content_type</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.error_content_type" title="Permalink to this definition">¶</a></dt>
<dd><p>Specifies the Content-Type HTTP header of error responses sent to the
client.  The default value is <code class="docutils literal"><span class="pre">'text/html'</span></code>.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.protocol_version">
<code class="descname">protocol_version</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.protocol_version" title="Permalink to this definition">¶</a></dt>
<dd><p>This specifies the HTTP protocol version used in responses.  If set to
<code class="docutils literal"><span class="pre">'HTTP/1.1'</span></code>, the server will permit HTTP persistent connections;
however, your server <em>must</em> then include an accurate <code class="docutils literal"><span class="pre">Content-Length</span></code>
header (using <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.send_header" title="http.server.BaseHTTPRequestHandler.send_header"><code class="xref py py-meth docutils literal"><span class="pre">send_header()</span></code></a>) in all of its responses to clients.
For backwards compatibility, the setting defaults to <code class="docutils literal"><span class="pre">'HTTP/1.0'</span></code>.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.MessageClass">
<code class="descname">MessageClass</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.MessageClass" title="Permalink to this definition">¶</a></dt>
<dd><p>Specifies an <a class="reference internal" href="email.message.html#email.message.Message" title="email.message.Message"><code class="xref py py-class docutils literal"><span class="pre">email.message.Message</span></code></a>-like class to parse HTTP
headers.  Typically, this is not overridden, and it defaults to
<code class="xref py py-class docutils literal"><span class="pre">http.client.HTTPMessage</span></code>.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.BaseHTTPRequestHandler.responses">
<code class="descname">responses</code><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.responses" title="Permalink to this definition">¶</a></dt>
<dd><p>This variable contains a mapping of error code integers to two-element tuples
containing a short and long message. For example, <code class="docutils literal"><span class="pre">{code:</span> <span class="pre">(shortmessage,</span>
<span class="pre">longmessage)}</span></code>. The <em>shortmessage</em> is usually used as the <em>message</em> key in an
error response, and <em>longmessage</em> as the <em>explain</em> key (see the
<a class="reference internal" href="#http.server.BaseHTTPRequestHandler.error_message_format" title="http.server.BaseHTTPRequestHandler.error_message_format"><code class="xref py py-attr docutils literal"><span class="pre">error_message_format</span></code></a> class variable).</p>
</dd></dl>

<p>A <a class="reference internal" href="#http.server.BaseHTTPRequestHandler" title="http.server.BaseHTTPRequestHandler"><code class="xref py py-class docutils literal"><span class="pre">BaseHTTPRequestHandler</span></code></a> instance has the following methods:</p>
<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.handle">
<code class="descname">handle</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.handle" title="Permalink to this definition">¶</a></dt>
<dd><p>Calls <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.handle_one_request" title="http.server.BaseHTTPRequestHandler.handle_one_request"><code class="xref py py-meth docutils literal"><span class="pre">handle_one_request()</span></code></a> once (or, if persistent connections are
enabled, multiple times) to handle incoming HTTP requests. You should
never need to override it; instead, implement appropriate <code class="xref py py-meth docutils literal"><span class="pre">do_*()</span></code>
methods.</p>
</dd></dl>

<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.handle_one_request">
<code class="descname">handle_one_request</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.handle_one_request" title="Permalink to this definition">¶</a></dt>
<dd><p>This method will parse and dispatch the request to the appropriate
<code class="xref py py-meth docutils literal"><span class="pre">do_*()</span></code> method.  You should never need to override it.</p>
</dd></dl>

<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.handle_expect_100">
<code class="descname">handle_expect_100</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.handle_expect_100" title="Permalink to this definition">¶</a></dt>
<dd><p>When a HTTP/1.1 compliant server receives an <code class="docutils literal"><span class="pre">Expect:</span> <span class="pre">100-continue</span></code>
request header it responds back with a <code class="docutils literal"><span class="pre">100</span> <span class="pre">Continue</span></code> followed by <code class="docutils literal"><span class="pre">200</span>
<span class="pre">OK</span></code> headers.
This method can be overridden to raise an error if the server does not
want the client to continue.  For e.g. server can chose to send <code class="docutils literal"><span class="pre">417</span>
<span class="pre">Expectation</span> <span class="pre">Failed</span></code> as a response header and <code class="docutils literal"><span class="pre">return</span> <span class="pre">False</span></code>.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.2.</span></p>
</div>
</dd></dl>

<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.send_error">
<code class="descname">send_error</code><span class="sig-paren">(</span><em>code</em>, <em>message=None</em>, <em>explain=None</em><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.send_error" title="Permalink to this definition">¶</a></dt>
<dd><p>Sends and logs a complete error reply to the client. The numeric <em>code</em>
specifies the HTTP error code, with <em>message</em> as an optional, short, human
readable description of the error.  The <em>explain</em> argument can be used to
provide more detailed information about the error; it will be formatted
using the <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.error_message_format" title="http.server.BaseHTTPRequestHandler.error_message_format"><code class="xref py py-attr docutils literal"><span class="pre">error_message_format</span></code></a> class variable and emitted, after
a complete set of headers, as the response body.  The <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.responses" title="http.server.BaseHTTPRequestHandler.responses"><code class="xref py py-attr docutils literal"><span class="pre">responses</span></code></a>
class variable holds the default values for <em>message</em> and <em>explain</em> that
will be used if no value is provided; for unknown codes the default value
for both is the string <code class="docutils literal"><span class="pre">???</span></code>.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>The error response includes a Content-Length header.
Added the <em>explain</em> argument.</p>
</div>
</dd></dl>

<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.send_response">
<code class="descname">send_response</code><span class="sig-paren">(</span><em>code</em>, <em>message=None</em><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.send_response" title="Permalink to this definition">¶</a></dt>
<dd><p>Adds a response header to the headers buffer and logs the accepted
request. The HTTP response line is written to the internal buffer,
followed by <em>Server</em> and <em>Date</em> headers. The values for these two headers
are picked up from the <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.version_string" title="http.server.BaseHTTPRequestHandler.version_string"><code class="xref py py-meth docutils literal"><span class="pre">version_string()</span></code></a> and
<a class="reference internal" href="#http.server.BaseHTTPRequestHandler.date_time_string" title="http.server.BaseHTTPRequestHandler.date_time_string"><code class="xref py py-meth docutils literal"><span class="pre">date_time_string()</span></code></a> methods, respectively. If the server does not
intend to send any other headers using the <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.send_header" title="http.server.BaseHTTPRequestHandler.send_header"><code class="xref py py-meth docutils literal"><span class="pre">send_header()</span></code></a> method,
then <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.send_response" title="http.server.BaseHTTPRequestHandler.send_response"><code class="xref py py-meth docutils literal"><span class="pre">send_response()</span></code></a> should be followed by an <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.end_headers" title="http.server.BaseHTTPRequestHandler.end_headers"><code class="xref py py-meth docutils literal"><span class="pre">end_headers()</span></code></a>
call.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.3: </span>Headers are stored to an internal buffer and <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.end_headers" title="http.server.BaseHTTPRequestHandler.end_headers"><code class="xref py py-meth docutils literal"><span class="pre">end_headers()</span></code></a>
needs to be called explicitly.</p>
</div>
</dd></dl>

<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.send_header">
<code class="descname">send_header</code><span class="sig-paren">(</span><em>keyword</em>, <em>value</em><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.send_header" title="Permalink to this definition">¶</a></dt>
<dd><p>Adds the HTTP header to an internal buffer which will be written to the
output stream when either <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.end_headers" title="http.server.BaseHTTPRequestHandler.end_headers"><code class="xref py py-meth docutils literal"><span class="pre">end_headers()</span></code></a> or <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.flush_headers" title="http.server.BaseHTTPRequestHandler.flush_headers"><code class="xref py py-meth docutils literal"><span class="pre">flush_headers()</span></code></a> is
invoked. <em>keyword</em> should specify the header keyword, with <em>value</em>
specifying its value. Note that, after the send_header calls are done,
<a class="reference internal" href="#http.server.BaseHTTPRequestHandler.end_headers" title="http.server.BaseHTTPRequestHandler.end_headers"><code class="xref py py-meth docutils literal"><span class="pre">end_headers()</span></code></a> MUST BE called in order to complete the operation.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.2: </span>Headers are stored in an internal buffer.</p>
</div>
</dd></dl>

<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.send_response_only">
<code class="descname">send_response_only</code><span class="sig-paren">(</span><em>code</em>, <em>message=None</em><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.send_response_only" title="Permalink to this definition">¶</a></dt>
<dd><p>Sends the response header only, used for the purposes when <code class="docutils literal"><span class="pre">100</span>
<span class="pre">Continue</span></code> response is sent by the server to the client. The headers not
buffered and sent directly the output stream.If the <em>message</em> is not
specified, the HTTP message corresponding the response <em>code</em>  is sent.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.2.</span></p>
</div>
</dd></dl>

<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.end_headers">
<code class="descname">end_headers</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.end_headers" title="Permalink to this definition">¶</a></dt>
<dd><p>Adds a blank line
(indicating the end of the HTTP headers in the response)
to the headers buffer and calls <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.flush_headers" title="http.server.BaseHTTPRequestHandler.flush_headers"><code class="xref py py-meth docutils literal"><span class="pre">flush_headers()</span></code></a>.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.2: </span>The buffered headers are written to the output stream.</p>
</div>
</dd></dl>

<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.flush_headers">
<code class="descname">flush_headers</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.flush_headers" title="Permalink to this definition">¶</a></dt>
<dd><p>Finally send the headers to the output stream and flush the internal
headers buffer.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.3.</span></p>
</div>
</dd></dl>

<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.log_request">
<code class="descname">log_request</code><span class="sig-paren">(</span><em>code='-'</em>, <em>size='-'</em><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.log_request" title="Permalink to this definition">¶</a></dt>
<dd><p>Logs an accepted (successful) request. <em>code</em> should specify the numeric
HTTP code associated with the response. If a size of the response is
available, then it should be passed as the <em>size</em> parameter.</p>
</dd></dl>

<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.log_error">
<code class="descname">log_error</code><span class="sig-paren">(</span><em>...</em><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.log_error" title="Permalink to this definition">¶</a></dt>
<dd><p>Logs an error when a request cannot be fulfilled. By default, it passes
the message to <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.log_message" title="http.server.BaseHTTPRequestHandler.log_message"><code class="xref py py-meth docutils literal"><span class="pre">log_message()</span></code></a>, so it takes the same arguments
(<em>format</em> and additional values).</p>
</dd></dl>

<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.log_message">
<code class="descname">log_message</code><span class="sig-paren">(</span><em>format</em>, <em>...</em><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.log_message" title="Permalink to this definition">¶</a></dt>
<dd><p>Logs an arbitrary message to <code class="docutils literal"><span class="pre">sys.stderr</span></code>. This is typically overridden
to create custom error logging mechanisms. The <em>format</em> argument is a
standard printf-style format string, where the additional arguments to
<a class="reference internal" href="#http.server.BaseHTTPRequestHandler.log_message" title="http.server.BaseHTTPRequestHandler.log_message"><code class="xref py py-meth docutils literal"><span class="pre">log_message()</span></code></a> are applied as inputs to the formatting. The client
ip address and current date and time are prefixed to every message logged.</p>
</dd></dl>

<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.version_string">
<code class="descname">version_string</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.version_string" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns the server software&#8217;s version string. This is a combination of the
<a class="reference internal" href="#http.server.BaseHTTPRequestHandler.server_version" title="http.server.BaseHTTPRequestHandler.server_version"><code class="xref py py-attr docutils literal"><span class="pre">server_version</span></code></a> and <a class="reference internal" href="#http.server.BaseHTTPRequestHandler.sys_version" title="http.server.BaseHTTPRequestHandler.sys_version"><code class="xref py py-attr docutils literal"><span class="pre">sys_version</span></code></a> class variables.</p>
</dd></dl>

<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.date_time_string">
<code class="descname">date_time_string</code><span class="sig-paren">(</span><em>timestamp=None</em><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.date_time_string" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns the date and time given by <em>timestamp</em> (which must be None or in
the format returned by <a class="reference internal" href="time.html#time.time" title="time.time"><code class="xref py py-func docutils literal"><span class="pre">time.time()</span></code></a>), formatted for a message
header. If <em>timestamp</em> is omitted, it uses the current date and time.</p>
<p>The result looks like <code class="docutils literal"><span class="pre">'Sun,</span> <span class="pre">06</span> <span class="pre">Nov</span> <span class="pre">1994</span> <span class="pre">08:49:37</span> <span class="pre">GMT'</span></code>.</p>
</dd></dl>

<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.log_date_time_string">
<code class="descname">log_date_time_string</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.log_date_time_string" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns the current date and time, formatted for logging.</p>
</dd></dl>

<dl class="method">
<dt id="http.server.BaseHTTPRequestHandler.address_string">
<code class="descname">address_string</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#http.server.BaseHTTPRequestHandler.address_string" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns the client address.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.3: </span>Previously, a name lookup was performed. To avoid name resolution
delays, it now always returns the IP address.</p>
</div>
</dd></dl>

</dd></dl>

<dl class="class">
<dt id="http.server.SimpleHTTPRequestHandler">
<em class="property">class </em><code class="descclassname">http.server.</code><code class="descname">SimpleHTTPRequestHandler</code><span class="sig-paren">(</span><em>request</em>, <em>client_address</em>, <em>server</em><span class="sig-paren">)</span><a class="headerlink" href="#http.server.SimpleHTTPRequestHandler" title="Permalink to this definition">¶</a></dt>
<dd><p>This class serves files from the current directory and below, directly
mapping the directory structure to HTTP requests.</p>
<p>A lot of the work, such as parsing the request, is done by the base class
<a class="reference internal" href="#http.server.BaseHTTPRequestHandler" title="http.server.BaseHTTPRequestHandler"><code class="xref py py-class docutils literal"><span class="pre">BaseHTTPRequestHandler</span></code></a>.  This class implements the <a class="reference internal" href="#http.server.SimpleHTTPRequestHandler.do_GET" title="http.server.SimpleHTTPRequestHandler.do_GET"><code class="xref py py-func docutils literal"><span class="pre">do_GET()</span></code></a>
and <a class="reference internal" href="#http.server.SimpleHTTPRequestHandler.do_HEAD" title="http.server.SimpleHTTPRequestHandler.do_HEAD"><code class="xref py py-func docutils literal"><span class="pre">do_HEAD()</span></code></a> functions.</p>
<p>The following are defined as class-level attributes of
<a class="reference internal" href="#http.server.SimpleHTTPRequestHandler" title="http.server.SimpleHTTPRequestHandler"><code class="xref py py-class docutils literal"><span class="pre">SimpleHTTPRequestHandler</span></code></a>:</p>
<dl class="attribute">
<dt id="http.server.SimpleHTTPRequestHandler.server_version">
<code class="descname">server_version</code><a class="headerlink" href="#http.server.SimpleHTTPRequestHandler.server_version" title="Permalink to this definition">¶</a></dt>
<dd><p>This will be <code class="docutils literal"><span class="pre">&quot;SimpleHTTP/&quot;</span> <span class="pre">+</span> <span class="pre">__version__</span></code>, where <code class="docutils literal"><span class="pre">__version__</span></code> is
defined at the module level.</p>
</dd></dl>

<dl class="attribute">
<dt id="http.server.SimpleHTTPRequestHandler.extensions_map">
<code class="descname">extensions_map</code><a class="headerlink" href="#http.server.SimpleHTTPRequestHandler.extensions_map" title="Permalink to this definition">¶</a></dt>
<dd><p>A dictionary mapping suffixes into MIME types. The default is
signified by an empty string, and is considered to be
<code class="docutils literal"><span class="pre">application/octet-stream</span></code>. The mapping is used case-insensitively,
and so should contain only lower-cased keys.</p>
</dd></dl>

<p>The <a class="reference internal" href="#http.server.SimpleHTTPRequestHandler" title="http.server.SimpleHTTPRequestHandler"><code class="xref py py-class docutils literal"><span class="pre">SimpleHTTPRequestHandler</span></code></a> class defines the following methods:</p>
<dl class="method">
<dt id="http.server.SimpleHTTPRequestHandler.do_HEAD">
<code class="descname">do_HEAD</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#http.server.SimpleHTTPRequestHandler.do_HEAD" title="Permalink to this definition">¶</a></dt>
<dd><p>This method serves the <code class="docutils literal"><span class="pre">'HEAD'</span></code> request type: it sends the headers it
would send for the equivalent <code class="docutils literal"><span class="pre">GET</span></code> request. See the <a class="reference internal" href="#http.server.SimpleHTTPRequestHandler.do_GET" title="http.server.SimpleHTTPRequestHandler.do_GET"><code class="xref py py-meth docutils literal"><span class="pre">do_GET()</span></code></a>
method for a more complete explanation of the possible headers.</p>
</dd></dl>

<dl class="method">
<dt id="http.server.SimpleHTTPRequestHandler.do_GET">
<code class="descname">do_GET</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#http.server.SimpleHTTPRequestHandler.do_GET" title="Permalink to this definition">¶</a></dt>
<dd><p>The request is mapped to a local file by interpreting the request as a
path relative to the current working directory.</p>
<p>If the request was mapped to a directory, the directory is checked for a
file named <code class="docutils literal"><span class="pre">index.html</span></code> or <code class="docutils literal"><span class="pre">index.htm</span></code> (in that order). If found, the
file&#8217;s contents are returned; otherwise a directory listing is generated
by calling the <code class="xref py py-meth docutils literal"><span class="pre">list_directory()</span></code> method. This method uses
<a class="reference internal" href="os.html#os.listdir" title="os.listdir"><code class="xref py py-func docutils literal"><span class="pre">os.listdir()</span></code></a> to scan the directory, and returns a <code class="docutils literal"><span class="pre">404</span></code> error
response if the <a class="reference internal" href="os.html#os.listdir" title="os.listdir"><code class="xref py py-func docutils literal"><span class="pre">listdir()</span></code></a> fails.</p>
<p>If the request was mapped to a file, it is opened and the contents are
returned.  Any <a class="reference internal" href="exceptions.html#OSError" title="OSError"><code class="xref py py-exc docutils literal"><span class="pre">OSError</span></code></a> exception in opening the requested file is
mapped to a <code class="docutils literal"><span class="pre">404</span></code>, <code class="docutils literal"><span class="pre">'File</span> <span class="pre">not</span> <span class="pre">found'</span></code> error. Otherwise, the content
type is guessed by calling the <code class="xref py py-meth docutils literal"><span class="pre">guess_type()</span></code> method, which in turn
uses the <em>extensions_map</em> variable.</p>
<p>A <code class="docutils literal"><span class="pre">'Content-type:'</span></code> header with the guessed content type is output,
followed by a <code class="docutils literal"><span class="pre">'Content-Length:'</span></code> header with the file&#8217;s size and a
<code class="docutils literal"><span class="pre">'Last-Modified:'</span></code> header with the file&#8217;s modification time.</p>
<p>Then follows a blank line signifying the end of the headers, and then the
contents of the file are output. If the file&#8217;s MIME type starts with
<code class="docutils literal"><span class="pre">text/</span></code> the file is opened in text mode; otherwise binary mode is used.</p>
<p>For example usage, see the implementation of the <a class="reference internal" href="test.html#module-test" title="test: Regression tests package containing the testing suite for Python."><code class="xref py py-func docutils literal"><span class="pre">test()</span></code></a> function
invocation in the <a class="reference internal" href="#module-http.server" title="http.server: HTTP server and request handlers."><code class="xref py py-mod docutils literal"><span class="pre">http.server</span></code></a> module.</p>
</dd></dl>

</dd></dl>

<p>The <a class="reference internal" href="#http.server.SimpleHTTPRequestHandler" title="http.server.SimpleHTTPRequestHandler"><code class="xref py py-class docutils literal"><span class="pre">SimpleHTTPRequestHandler</span></code></a> class can be used in the following
manner in order to create a very basic webserver serving files relative to
the current directory:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">import</span> <span class="nn">http.server</span>
<span class="kn">import</span> <span class="nn">socketserver</span>

<span class="n">PORT</span> <span class="o">=</span> <span class="mi">8000</span>

<span class="n">Handler</span> <span class="o">=</span> <span class="n">http</span><span class="o">.</span><span class="n">server</span><span class="o">.</span><span class="n">SimpleHTTPRequestHandler</span>

<span class="n">httpd</span> <span class="o">=</span> <span class="n">socketserver</span><span class="o">.</span><span class="n">TCPServer</span><span class="p">((</span><span class="s">&quot;&quot;</span><span class="p">,</span> <span class="n">PORT</span><span class="p">),</span> <span class="n">Handler</span><span class="p">)</span>

<span class="nb">print</span><span class="p">(</span><span class="s">&quot;serving at port&quot;</span><span class="p">,</span> <span class="n">PORT</span><span class="p">)</span>
<span class="n">httpd</span><span class="o">.</span><span class="n">serve_forever</span><span class="p">()</span>
</pre></div>
</div>
<p id="http-server-cli"><a class="reference internal" href="#module-http.server" title="http.server: HTTP server and request handlers."><code class="xref py py-mod docutils literal"><span class="pre">http.server</span></code></a> can also be invoked directly using the <a class="reference internal" href="../using/cmdline.html#cmdoption-m"><code class="xref std std-option docutils literal"><span class="pre">-m</span></code></a>
switch of the interpreter with a <code class="docutils literal"><span class="pre">port</span> <span class="pre">number</span></code> argument.  Similar to
the previous example, this serves files relative to the current directory:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="n">python</span> <span class="o">-</span><span class="n">m</span> <span class="n">http</span><span class="o">.</span><span class="n">server</span> <span class="mi">8000</span>
</pre></div>
</div>
<p>By default, server binds itself to all interfaces.  The option <code class="docutils literal"><span class="pre">-b/--bind</span></code>
specifies a specific address to which it should bind.  For example, the
following command causes the server to bind to localhost only:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="n">python</span> <span class="o">-</span><span class="n">m</span> <span class="n">http</span><span class="o">.</span><span class="n">server</span> <span class="mi">8000</span> <span class="o">--</span><span class="n">bind</span> <span class="mf">127.0</span><span class="o">.</span><span class="mf">0.1</span>
</pre></div>
</div>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.4: </span><code class="docutils literal"><span class="pre">--bind</span></code> argument was introduced.</p>
</div>
<dl class="class">
<dt id="http.server.CGIHTTPRequestHandler">
<em class="property">class </em><code class="descclassname">http.server.</code><code class="descname">CGIHTTPRequestHandler</code><span class="sig-paren">(</span><em>request</em>, <em>client_address</em>, <em>server</em><span class="sig-paren">)</span><a class="headerlink" href="#http.server.CGIHTTPRequestHandler" title="Permalink to this definition">¶</a></dt>
<dd><p>This class is used to serve either files or output of CGI scripts from the
current directory and below. Note that mapping HTTP hierarchic structure to
local directory structure is exactly as in <a class="reference internal" href="#http.server.SimpleHTTPRequestHandler" title="http.server.SimpleHTTPRequestHandler"><code class="xref py py-class docutils literal"><span class="pre">SimpleHTTPRequestHandler</span></code></a>.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">CGI scripts run by the <a class="reference internal" href="#http.server.CGIHTTPRequestHandler" title="http.server.CGIHTTPRequestHandler"><code class="xref py py-class docutils literal"><span class="pre">CGIHTTPRequestHandler</span></code></a> class cannot execute
redirects (HTTP code 302), because code 200 (script output follows) is
sent prior to execution of the CGI script.  This pre-empts the status
code.</p>
</div>
<p>The class will however, run the CGI script, instead of serving it as a file,
if it guesses it to be a CGI script.  Only directory-based CGI are used &#8212;
the other common server configuration is to treat special extensions as
denoting CGI scripts.</p>
<p>The <code class="xref py py-func docutils literal"><span class="pre">do_GET()</span></code> and <code class="xref py py-func docutils literal"><span class="pre">do_HEAD()</span></code> functions are modified to run CGI scripts
and serve the output, instead of serving files, if the request leads to
somewhere below the <code class="docutils literal"><span class="pre">cgi_directories</span></code> path.</p>
<p>The <a class="reference internal" href="#http.server.CGIHTTPRequestHandler" title="http.server.CGIHTTPRequestHandler"><code class="xref py py-class docutils literal"><span class="pre">CGIHTTPRequestHandler</span></code></a> defines the following data member:</p>
<dl class="attribute">
<dt id="http.server.CGIHTTPRequestHandler.cgi_directories">
<code class="descname">cgi_directories</code><a class="headerlink" href="#http.server.CGIHTTPRequestHandler.cgi_directories" title="Permalink to this definition">¶</a></dt>
<dd><p>This defaults to <code class="docutils literal"><span class="pre">['/cgi-bin',</span> <span class="pre">'/htbin']</span></code> and describes directories to
treat as containing CGI scripts.</p>
</dd></dl>

<p>The <a class="reference internal" href="#http.server.CGIHTTPRequestHandler" title="http.server.CGIHTTPRequestHandler"><code class="xref py py-class docutils literal"><span class="pre">CGIHTTPRequestHandler</span></code></a> defines the following method:</p>
<dl class="method">
<dt id="http.server.CGIHTTPRequestHandler.do_POST">
<code class="descname">do_POST</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#http.server.CGIHTTPRequestHandler.do_POST" title="Permalink to this definition">¶</a></dt>
<dd><p>This method serves the <code class="docutils literal"><span class="pre">'POST'</span></code> request type, only allowed for CGI
scripts.  Error 501, &#8220;Can only POST to CGI scripts&#8221;, is output when trying
to POST to a non-CGI url.</p>
</dd></dl>

<p>Note that CGI scripts will be run with UID of user nobody, for security
reasons.  Problems with the CGI script will be translated to error 403.</p>
</dd></dl>

<p><a class="reference internal" href="#http.server.CGIHTTPRequestHandler" title="http.server.CGIHTTPRequestHandler"><code class="xref py py-class docutils literal"><span class="pre">CGIHTTPRequestHandler</span></code></a> can be enabled in the command line by passing
the <code class="docutils literal"><span class="pre">--cgi</span></code> option:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="n">python</span> <span class="o">-</span><span class="n">m</span> <span class="n">http</span><span class="o">.</span><span class="n">server</span> <span class="o">--</span><span class="n">cgi</span> <span class="mi">8000</span>
</pre></div>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="socketserver.html"
                        title="previous chapter">21.21. <code class="docutils literal"><span class="pre">socketserver</span></code> &#8212; A framework for network servers</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="http.cookies.html"
                        title="next chapter">21.23. <code class="docutils literal"><span class="pre">http.cookies</span></code> &#8212; HTTP state management</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/http.server.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="http.cookies.html" title="21.23. http.cookies — HTTP state management"
             >next</a> |</li>
        <li class="right" >
          <a href="socketserver.html" title="21.21. socketserver — A framework for network servers"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="internet.html" >21. Internet Protocols and Support</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>